/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

#define BUTTON1  1
#define BUTTON2  2

static void ButtonCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{                   /* VVVVVV Judge the widget by client data */
    int which = (int)client_data;
    printf("Button %d is clicked.\n", which);
    printf("Widget Name: %s\n", XtName(w));
}                                  /*  ^ Judge the Widget ID */

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, rowcol, button1, button2;
    Arg     al[20];
    int     ac;


    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Callbackshar", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    rowcol = XmCreateRowColumn(toplevel, "rowcol", al, ac);
    XtManageChild(rowcol);

    ac = 0;
    button1 = XmCreatePushButton(rowcol, "button1", al, ac);
    XtAddCallback(button1, XmNactivateCallback, ButtonCB, BUTTON1);
    XtManageChild(button1);          /* Pass a client data AAAAAA */

    ac = 0;
    button2 = XmCreatePushButton(rowcol, "button2", al, ac);
    XtAddCallback(button2, XmNactivateCallback, ButtonCB, BUTTON2);
    XtManageChild(button2);          /* Pass a client data AAAAAA */

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}
