/***********************************************************************
 *      This example program is an excerpt from the book:              *
 *                                                                     *
 *          X Window OSF/Motif Toolkit Programming (I)                 *
 *            - Programming Basics, Resource and Event -               *
 *                                                                     *
 *      Copyright 1994, Hideyuki Hayashi                               *
 *                                                                     *
 *      This program can be distributed without fee, provided          *
 *      that the above copyright notice appear in all copies.          *
 ***********************************************************************/

#include <Xm/XmAll.h>

/* Declare fallback resources */
static String fallbacks[] = {
    "Fallbackdef.title:                  Simple Motif Example",
    "Fallbackdef*control.orientation:    HORIZONTAL",
    "Fallbackdef*fontList:               *-14-*:",
    "Fallbackdef*label.labelString:      File Name",
    "Fallbackdef*button.labelString:     Open",
    NULL
};

static void ButtonCB();

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget  toplevel, panel, control, label, text, button;
    Arg     al[20];
    int     ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Fallbackdef", NULL, 0,
                               &argc, argv, fallbacks, al, ac);
                                         /* AAAAAAAAA */
                                    /* Specify fallback resources */
    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);

    ac = 0;
    label = XmCreateLabel(control, "label", al, ac);
    XtManageChild(label);

    ac = 0;
    text = XmCreateTextField(control, "text", al, ac);
    XtManageChild(text);

    ac = 0;
    button = XmCreatePushButton(panel, "button", al, ac);
    XtManageChild(button);

    XtAddCallback(button, XmNactivateCallback, ButtonCB, text);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

static void ButtonCB(w, client_data, call_data)
    Widget    w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget) client_data;
    char *filename;

    filename = XmTextFieldGetString(text);
    printf("Entered file name: %s\n", filename);
    XtFree(filename);
}
